//
// Copyright 2002-2006 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Slides. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//

import com.aspose.slides.*;

import java.io.*;
import java.util.TreeMap;

public class CloneSlide {

    public static void main(String args[]) {

        if (args.length != 3) {
            System.out.println("Usage: java ppt2ppt <source file> <destination file>");
            System.exit(0);
        }

        //
        // Open and set license
        //
        // License lic = new License();
        // try {
        //     lic.setLicense(new FileInputStream(new File("Aspose.Slides.lic")));
        // } catch (Exception e) {
        // }

        try {
            Presentation part1 = new Presentation(new FileInputStream(new File(args[0])));
            Presentation part2 = new Presentation(new FileInputStream(new File(args[1])));

            // Copy all slides from the second presentation
            // to the end of the first one.
            TreeMap ids = new TreeMap();
            for (int i = 0; i < part2.getSlides().size(); i++) {
                if (part2.getSlides().get(i).getSlidePosition() != 0) {
                    ids.clear();
                    Slide sl = part2.cloneSlide(part2.getSlides().get(i),
                            part1.getSlides().getLastSlidePosition() + 1, part1, ids);
                }
            }
            part1.write(new FileOutputStream(new File(args[2])));
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }
}
