//
// Copyright 2002-2006 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Slides. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//

import com.aspose.slides.Presentation;
import com.aspose.slides.Slide;
import com.aspose.slides.OleObjectFrame;
import com.aspose.slides.Shape;

import java.io.FileInputStream;
import java.io.File;
import java.io.FileOutputStream;

public class OleDemo {

    public static void main(String args[]) {

        try {
            //
            // Licensing the Aspose.Slides component
            //
            // License license = new License();
            // license.setLicense("Aspose.Slides.lic");

            String fname = "excel1.xls";

            // Open presentation with excel chart
            FileInputStream fis = new FileInputStream(new File("pres1.ppt"));
            Presentation pres1 = new Presentation(fis);
            Slide slide = pres1.getSlideByPosition(1);

            // Find excel chart shape and save it to .xls file.
            OleObjectFrame oof = null;
            Shape sh = slide.findShape("chart");
            if (sh instanceof OleObjectFrame)
                oof = (OleObjectFrame) sh;

            if (oof != null) {
                FileOutputStream fstr = new FileOutputStream(new File(fname));
                byte[] buf = oof.getObjectData();
                fstr.write(buf, 0, buf.length);
                fstr.flush();
                fstr.close();
            }

            // Open target presentation
            fis = new FileInputStream(new File("pres2.ppt"));
            Presentation pres2 = new Presentation(fis);
            slide = pres2.getSlideByPosition(1);

            // Read excel chart from file and insert it as new
            // OleObjectFrame to a slide.
            FileInputStream fstro = new FileInputStream(new File(fname));
            byte[] b = new byte[fstro.available()];
            fstro.read(b, 0, (int) fstro.available());
            oof = slide.getShapes().addOleObjectFrame(0, 0, pres2.getSlideSize().x, pres2.getSlideSize().y,
                    "Excel.Sheet.8", b);

            FileOutputStream fos = new FileOutputStream(new File("pres_new.ppt"));
            pres2.write(fos);
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }
}
