package com.aspose.demo;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

import com.aspose.slides.*;

import java.net.URL;

public class JavaPPT extends HttpServlet {

    private static final String CONTENT_TYPE = "text/html; Latin-1";

    //Initialize global variables
    public void init() throws ServletException {
    }

    //Process the HTTP Get request
    public void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType(CONTENT_TYPE);
        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<head>\n" +
                "<title>Aspose.Slides Web Template demo</title>\n" +
                "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n" +
                "<link href=\"http://www.aspose.com/aspose.css\" type=\"text/css\" rel=\"stylesheet\">\n" +
                "</head>");

        out.println("<body background=\"http://www.aspose.com/images/imgBack.gif\">");
        String header = "<iframe src=\"http://www.aspose.com/Header/Header.aspx\" frameborder=\"0\" width=\"100%\" scrolling=\"no\"></iframe>";
        out.println(header);

        out.println("<p class=\"i1\">Welcome to the <strong>Aspose.Slides for Java Featured Demos</strong>!</p>");
        out.println("<p class=\"i1\">&nbsp;</p>");
        out.println("<p class=\"i1\">The demo loads PowerPoint presentation, modifies and displayes it</p> ");
        out.println("<form method=post>");
        out.println("<input type=submit value=\"Run DEMO\">");
        out.println("</form");

        String footer = "<div id=\"footer\">" +
                "<p><a href=\"http://www.aspose.com/Corporate/Aspose/Contactaspose.html\">We guarantee a prompt response to any inquiry!</a></p>" +
                "<p></p></body></html>";
        out.println(footer);
    }

    //Process the HTTP Post request
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        Presentation pres;

        FileInputStream source = null;
        FileOutputStream destination = null;
        PrintStream dataOut = null;
        DataInputStream dataIn;

        try {
            ServletContext context = request.getSession().getServletContext();
            String realContextPath = context.getRealPath(request.getContextPath());

            int pos = realContextPath.lastIndexOf("\\");
            realContextPath = realContextPath.substring(0, pos);

            String pptPath = realContextPath + "\\" + "demo.ppt";
            String destPath = realContextPath + "\\" + "demo_new.ppt";
            source = new FileInputStream(pptPath);
            destination = new FileOutputStream(destPath);

            pres = new Presentation(source);

            Slides slides = pres.getSlides();
            for (int i = 0; i < slides.size(); i++) {
                // Set text of standard slide placeholders
                Placeholders pholders = slides.get(i).getPlaceholders();
                for (int j = 0; j < pholders.size(); j++) {
                    if (pholders.get(j) instanceof TextHolder) {
                        TextHolder th = (TextHolder) pholders.get(j);
                        if (th.getText().equals("H1"))
                            th.getParagraphs().get(0).getPortions().get(0).setText("Demo Presentation");
                        else if (th.getText().equals("SH1"))
                            th.getParagraphs().get(0).getPortions().get(0).setText("Aspose.Slides.Template");
                        else if (th.getText().equals("T1")) {
                            switch (i) {
                                case 1:
                                    Paragraph newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("With Aspose.Slides you can:");
                                    th.getParagraphs().add(newPara);
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("Open, read and save Microsoft PowerPoint presentations.");
                                    th.getParagraphs().add(newPara);
                                    th.getParagraphs().remove(0);
                                    break;
                                case 2:
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("With Aspose.Slides you can:");
                                    th.getParagraphs().add(newPara);
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("Change standard text placeholders as well as custom text frames.");
                                    th.getParagraphs().add(newPara);
                                    th.getParagraphs().remove(0);
                                    break;
                                case 3:
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("With Aspose.Slides you can:");
                                    th.getParagraphs().add(newPara);
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("Replace background pictures with any picture from presentation or new picture.");
                                    th.getParagraphs().add(newPara);
                                    th.getParagraphs().remove(0);
                                    break;
                            }
                        }
                    }
                }

                // Set text for text frames
                Shapes shapes = slides.get(i).getShapes();
                for (int j = 0; j < shapes.size(); j++) {
                    TextFrame tf = shapes.get(j).getTextFrame();
                    if (tf != null) {
                        if (tf.getText().equals("CT1"))
                            tf.getParagraphs().get(0).getPortions().get(0).setText("Created on:");
                        else if (tf.getText().equals("CT2"))
                            tf.getParagraphs().get(0).getPortions().get(0).setText(new Date().toString());
                        else if (tf.getText().equals("P1")) {
                            tf.getParagraphs().get(0).getPortions().get(0).setText("Slide " + (i + 1));
                        }
                    }
                }
            }

            pres.write(destination);
            source.close();
            destination.close();

            String servletPath = request.getRequestURL().toString();
            pos = servletPath.lastIndexOf("/");
            String pptDemoPath = servletPath.substring(0, pos) + "/" + "demo_new.ppt";

            ServletOutputStream out = response.getOutputStream();

            response.setContentType("application/vnd.ms-powerpoint");
            response.addHeader("Content-Disposition", "attachment; filename=demo_new.ppt");

            BufferedInputStream bis = null;
            BufferedOutputStream bos = null;

            URL url = new URL(pptDemoPath);

            // Use Buffered Stream for reading/writing.
            bis = new BufferedInputStream(url.openStream());
            bos = new BufferedOutputStream(out);

            byte[] buff = new byte[2048];
            int bytesRead;

            // Simple read/write loop.
            while (-1 != (bytesRead = bis.read(buff, 0, buff.length))) {
                bos.write(buff, 0, bytesRead);
            }

            bis.close();
            bos.flush();
            bos.close();

            response.flushBuffer();
        } catch (Exception e) {
            response.setContentType("text/html");
            PrintWriter out = response.getWriter();
            out.println("<html>");
            out.println("<head>");
            out.println("<title>The POST method</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("The exception has been thrown.<br>");
            out.println(e.getMessage());
            out.println("</body>");
            out.println("</html>");
        }
    }

    //Clean up resources
    public void destroy() {
    }
}
