//
// Copyright 2002-2006 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Slides. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//

import com.aspose.slides.*;

import java.io.*;
import java.util.Date;

public class Template {

    public static void main(String args[]) {

        Presentation pres;

        if (args.length != 3) {
            System.out.println("Usage: java ppt2ppt <source file> <destination file>");
            System.exit(0);
        }

        //
        // Open and set license
        //
        //License lic = new License();
        //try {
        //    lic.setLicense(new FileInputStream(new File("Aspose.Slides.lic")));
        //} catch (Exception e) {
        //}

        try {
            destination = new FileOutputStream(dest_file);

            pres = new Presentation(new FileInputStream(new File(args[0])));

            Slides slides = pres.getSlides();
            for (int i = 0; i < slides.size(); i++) {
                // Set text of standard slide placeholders
                Placeholders pholders = slides.get(i).getPlaceholders();
                for (int j = 0; j < pholders.size(); j++) {
                    if (pholders.get(j) instanceof TextHolder) {
                        TextHolder th = (TextHolder) pholders.get(j);
                        if (th.getText().equals("H1"))
                            th.getParagraphs().get(0).getPortions().get(0).setText("Demo Presentation");
                        else if (th.getText().equals("SH1"))
                            th.getParagraphs().get(0).getPortions().get(0).setText("Aspose.Slides.Template");
                        else if (th.getText().equals("T1")) {
                            switch (i) {
                                case 1:
                                    Paragraph newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("With Aspose.Slides you can:");
                                    th.getParagraphs().add(newPara);
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("Open, read and save Microsoft PowerPoint presentations.");
                                    th.getParagraphs().add(newPara);
                                    th.getParagraphs().remove(0);
                                    break;
                                case 2:
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("With Aspose.Slides you can:");
                                    th.getParagraphs().add(newPara);
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("Change standard text placeholders as well as custom text frames.");
                                    th.getParagraphs().add(newPara);
                                    th.getParagraphs().remove(0);
                                    break;
                                case 3:
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("With Aspose.Slides you can:");
                                    th.getParagraphs().add(newPara);
                                    newPara = new Paragraph(th.getParagraphs().get(0));
                                    newPara.getPortions().get(0).setText("Replace background pictures with any picture from presentation or new picture.");
                                    th.getParagraphs().add(newPara);
                                    th.getParagraphs().remove(0);
                                    break;
                            }
                        }
                    }
                }

                // Set text for text frames
                Shapes shapes = slides.get(i).getShapes();
                for (int j = 0; j < shapes.size(); j++) {
                    TextFrame tf = shapes.get(j).getTextFrame();
                    if (tf != null) {
                        if (tf.getText().equals("CT1"))
                            tf.getParagraphs().get(0).getPortions().get(0).setText("Created on:");
                        else if (tf.getText().equals("CT2"))
                            tf.getParagraphs().get(0).getPortions().get(0).setText(new Date().toString());
                        else if (tf.getText().equals("P1")) {
                            tf.getParagraphs().get(0).getPortions().get(0).setText("Slide " + (i + 1));
                        }
                    }
                }
            }

            pres.write(new FileOutputStream(new File(args[1])));
        } catch (IOException e) {
            System.err.println(e);
        }
    }
}
